
#include "ggi_widget.h"

#include <ggi/ggi.h>

typedef struct ggiWidgetChildList {
	struct ggiWidgetChildList *next;
	ggi_widget_t		  child;
} ggi_widget_childlist_struct;

typedef ggi_widget_childlist_struct *ggi_widget_childlist_t;

ggi_widget_t ggiWidgetSingleChildGet   (ggi_widget_t widget,int childnum);
int          ggiWidgetSingleChildLink  (ggi_widget_t widget,int childnum,ggi_widget_t newchild,...);
ggi_widget_t ggiWidgetSingleChildUnlink(ggi_widget_t widget,int childnum);
ggi_widget_t ggiWidgetChildlistGet   (ggi_widget_t widget,int childnum);
int          ggiWidgetChildlistLink  (ggi_widget_t widget,int childnum,ggi_widget_t newchild,...);
ggi_widget_t ggiWidgetChildlistUnlink(ggi_widget_t widget,int childnum);

int ggiWidgetRedrawChildren(ggi_widget_t self);
int ggiWidgetDestroyChildren(ggi_widget_t self);

int ggiWidgetGetPlacement(ggi_widget_t widget,ggi_widget_size_t *pos,ggi_widget_size_t *size,int *opt,int nsx,int nsy);
int ggiWidgetDrawBorder  (ggi_widget_t widget,ggi_widget_size_t *pos,ggi_widget_size_t *size);

struct ggiWidgetInputStatusMouse {
	int x,y,z,wheel;

	int buttonmask;
	
	int lcx,lcy;
	struct  timeval lastclicktime;
	int clickcount;
};

struct ggiWidgetInputStatusKey {
	uint32  modifiers;
};

typedef struct ggiWidgetInputStatus {

	struct ggiWidgetInputStatus *next;

	ggi_visual_t vis;
	ggi_widget_childlist_t children;

	struct ggiWidgetInputStatusMouse mouse;

	struct ggiWidgetInputStatusKey key;
	
} ggi_widget_inputstatus_struct;

typedef ggi_widget_inputstatus_struct *ggi_widget_inputstatus_t;


int ggiWidgetDrawFrame(ggi_visual_t vis,int x,int y,int w,int h,int thick);
